config/routes.rb
Rails.application.routes.draw do
  resources :users, except: [:index]

  get 'signup' => "users#new", as: :signup

  get 'login' => "users#login", as: 'login'
   
  post '/login' => "users#authenticate"

  delete 'logout/:id' => "users#logout", as: :logout

  post "pins/repin/:id" => "pins#repin", as: 'repin'

  root 'pins#index'

  get '/library' => 'pins#index'

  get "pins/name-:slug" => "pins#show_by_name", as: 'pin_by_name'

  resources :pins

end

app/models/category.rb
class Category < ActiveRecord::Base
	has_many :pins
end

app/models/pin.rb
class Pin < ActiveRecord::Base
  validates_presence_of :title, :url, :slug, :text, :category_id, :user_id
  validates_uniqueness_of :slug
  belongs_to :category
  has_many :pinnings
  has_many :users, through: :pinnings

  has_attached_file :image, styles: {medium: "300x300>", thumb: "60x60>"}, default_url: "http://placebear.com/300/300"
  validates_attachment :image, content_type: {content_type: ["image/jpg", "image/jpeg", "image/png", "image/gif"] }
end

app/models/pinning.rb
class Pinning < ActiveRecord::Base
  belongs_to :pin
  belongs_to :user
end

app/models/user.rb
class User < ActiveRecord::Base
	has_secure_password
	validates_presence_of :first_name, :last_name, :email, :password
	validates_uniqueness_of :email
	has_many :pinnings
	has_many :pins, through: :pinnings

	def self.authenticate(email, password)
	  @user = User.find_by_email(email)
 
	  if !@user.nil?
	    if @user.authenticate(password)
	      return @user
	    end
	  end
		  
	  return nil
	end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

	def current_user
	  @user ||= User.where("id=?",session[:user_id]).first
	end
	helper_method :current_user

	def require_login
    if current_user.nil?
      redirect_to :login
    end
  end

end

app/controllers/pins_controller.rb
class PinsController < ApplicationController
  before_action :require_login, except: [:show, :show_by_name, :index]
  
  def index
    @pins = Pin.all
  end
  
  def show
    @pin = Pin.find(params[:id])
    @users = @pin.users
  end
  
  def show_by_name
  	@pin = Pin.find_by_slug(params[:slug])
    @users = @pin.users
  	render :show
  end

  def new
    @pin = Pin.new
  end

  def edit
    @pin = Pin.find(params[:id])
  end

  def update
    @pin = Pin.find(params[:id])
 
  if @pin.update(pin_params)
    redirect_to pin_path(@pin)
  else
    @errors = @pin.errors
    render :edit
    # redirect_to edit_pin_path(@pin)
    end
  end

  def create
    @pin = Pin.create(pin_params)
 
  if @pin.valid?
    @pin.save
    redirect_to pin_path(@pin)
  else
    @errors = @pin.errors
    render :new
    end
  end

  def repin
    @pin = Pin.find(params[:id])
    @pin.pinnings.create(user: current_user)
    redirect_to user_path(current_user)
  end
    
  private
 
  def pin_params
    params.require(:pin).permit(:title, :url, :slug, :text, :category_id, :image, :user_id)
  end

end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :require_login, only: [:show, :edit, :update, :destroy]

  # GET /users
  # GET /users.json

  def login
  end

  def logout
    session.delete(:user_id)
    redirect_to :login
  end

   def authenticate
    @user = User.authenticate(params[:email], params[:password]) 
    if !@user.nil?
      session[:user_id] = @user.id
      redirect_to user_path(@user)
    else
      @errors = "User or password do not match"
      render :login
    end
  end

  def index
    @users = User.all
  end

  # GET /users/1
  # GET /users/1.json
  def show
    @pins = current_user.pins
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        format.html { redirect_to @user, notice: 'User was successfully created.' }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to @user, notice: 'User was successfully updated.' }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: 'User was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    # def set_user
    #   @user = User.find(params[:id])
    # end

    # Never trust parameters from the scary internet, only allow the white list through.
    def user_params
      params.require(:user).permit(:first_name, :last_name, :email, :password)
    end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Coder Pinterest</title>
  <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css">
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>
  <div class="container">
  	
  	<div class="pull-right">
	  <h3>
	  	<% if !current_user.nil? && current_user.first_name != nil %>
	    	<%= "Hi, #{current_user.first_name}!"%>
	    	<%= link_to "Logout", logout_path(current_user), method: :delete %>
	    <% end %>
	  </h3>
	</div>
	
    <%= yield %>
  </div>
</body>
</html>

app/views/pins/_form.erb
<% if !@errors.nil? %>
  <div class="error alert alert-danger">
    <label><%= pluralize(@errors.count, "error") %> prohibited this pin from being saved:</label>
    <ul>
      <% @errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
    </ul>
  </div>
<% end %>

<div class="form-wrapper">
<%= form_for @pin do |f| %>

	<div class="form-group">
		<label for="pin_image">Image</label>
  		<%= f.file_field :image, :class => 'form-control'  %>
	</div>
	<div class="form-group">
		<label for="pin_title">Title</label>
		<%= f.text_field :title, :class => 'form-control' %>
	</div>

	<div class="form-group">
		<label for="pin_url">URL</label>
		<%= f.text_field :url, :class => 'form-control' %>
	</div>

	<div class="form-group">
		<label for="pin_text">Text</label>
		<%= f.text_area :text, :class => 'form-control' %>
	</div>

	<div class="form-group">
		<label for="pin_text">Slug</label>
		<%= f.text_field :slug, :class => 'form-control' %>
	</div>
	
	<div class="form-group">
		<label for="pin_category_id">Category</label>
	  	<%= f.collection_select(:category_id, Category.all, :id, :name, value: @pin.category, class: "form-control")  %>
  	</div>

  	<%= f.hidden_field :user_id, value: current_user.id %> 

  	<div class="form-group">
  		<%= f.submit :class => 'btn btn-success' %>
  	</div>
<% end %>
</div>

app/views/pins/edit.erb
<div class="header">
  <h1>
    <i class="fa fa-laptop"></i>
    Let's edit this pin
  </h1>
</div>

<%= render "form" %>

app/views/pins/index.erb
<div class="header">
  <h1>Learning to Code</h1>
  <h3>A Collection of Ruby on Rails Resources for Beginners</h3>
</div>
<hr/>
<div class="pins">
  <% @pins.each_slice(3) do |row| %>
    <div class="row">
      <% row.each do |pin| %>      
        <div class="pin-container col-md-4">
          <div class="pin">

            <div class="logo-thumbnail col-xs-3">
              <% if pin.image.exists? %>
                <img src="<%= pin.image.url(:thumb) %>">
              <% else %>
                <% if "#{pin.category.name}" == "rails" %>
                  <%= image_tag('rails-logo-thumbnail.png') %>
                <% elsif "#{pin.category.name}" == "ruby" %>
                  <%= image_tag('ruby-logo-thumbnail.png') %>                
                <% end %>
              <% end %>
            </div>

            <div class="col-xs-9">
              <h4>
                <%= link_to "#{pin.title}", pin_by_name_path(slug: pin.slug), html_options = {target: "_blank", class: "url"} %>
              </h4>
              <%= link_to "#{pin.url}", pin.url, html_options = {target: "_blank", class: "url"} %>
            </div>

            <hr/>
            <%= link_to repin_path(pin), class: "btn btn-default repin", method: "post" do %>
              <i class="fa fa-thumb-tack"></i>
              Repin!
            <% end %>
            <img src="<%= pin.image.url(:medium) %>">
            <p class="text"><%= "#{pin.text}" %></p>
          </div>
        </div>
      <% end %>
    </div>
  <% end %>
</div>

<hr/>

app/views/pins/new.erb
<div class="header">
  <h1>
    <i class="fa fa-laptop"></i>
    Let's create a new pin
  </h1>
</div>

<%= render "form" %>

app/views/pins/show.erb
<div class="header">
  <h1>
    <i class="fa fa-laptop"></i>
    <%= "#{@pin.title}" %>
  </h1>
</div>

<div class="show-pin">
  <p><%= "#{@pin.text}" %></p>
  <p>
    This pin has been pinned by
    <% @users.each do |user| %>
      <%= link_to user.first_name.capitalize, user_path(user), target: "_blank" %>
    <% end %>
  </p>
  <hr/>
  <img src="<%= @pin.image.url(:medium) %>">
  <p>
    <b>Visit <%= "#{@pin.title}" %> at: </b>
    <a class="url" href="<%= "#{@pin.url}" %>" target="_blank">
      <%= "#{@pin.url}" %>
    </a>
  </p>
  <%= link_to repin_path(@pin), class: "btn btn-default", method: "post" do %>
    <i class="fa fa-thumb-tack"></i>
    Repin!
  <% end %>
</div>
<br/>
<a href="/">
  <i class="fa fa-arrow-circle-left"></i>
  Back to Home
</a>

app/views/users/_error_display.erb
<% unless @errors.nil? %>
  <div class="alert alert-dismissible alert-danger">
    <label> <%= pluralize(@errors.count) %> prohibited this pin from being saved: </label>
      <ul>
        <% @errors.full_messages.each do |msg| %>
          <li> <%= msg %> </li>
        <% end %>  
      </ul>
  </div>
<% end %>

app/views/users/_form.html.erb
<%= form_for(@user) do |f| %>
  <% if @user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% @user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :first_name %><br>
    <%= f.text_field :first_name %>
  </div>
  <div class="field">
    <%= f.label :last_name %><br>
    <%= f.text_field :last_name %>
  </div>
  <div class="field">
    <%= f.label :email %><br>
    <%= f.text_field :email %>
  </div>
  <div class="field">
    <%= f.label :password %><br>
    <%= f.text_field :password %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/users/edit.html.erb
<h1>Editing User</h1>

<%= render 'form' %>

<%= link_to 'Show', @user %> |
<%= link_to 'Back', users_path %>

app/views/users/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Users</h1>

<table>
  <thead>
    <tr>
      <th>First name</th>
      <th>Last name</th>
      <th>Email</th>
      <th>Password</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td><%= user.first_name %></td>
        <td><%= user.last_name %></td>
        <td><%= user.email %></td>
        <td><%= user.password %></td>
        <td><%= link_to 'Show', user %></td>
        <td><%= link_to 'Edit', edit_user_path(user) %></td>
        <td><%= link_to 'Destroy', user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New User', new_user_path %>

app/views/users/login.html.erb
<h1>Login</h1>



<%= form_tag "/login", class: 'form-wrapper login' do |f| %>
	<div class="form-group">
 		<%= text_field_tag 'email', nil, placeholder: 'Email', class: 'form-control' %>
 	</div>
 	<div class="form-group">
 		<%= password_field_tag(:password, nil, placeholder: 'Password', class: 'form-control') %>
 	</div>
 	<div class="form-group">
 		<%= submit_tag 'Login', class: 'btn btn-success' %>
 	</div>
<% end %>

app/views/users/new.html.erb
<h1>Sign Up</h1>

<%= render 'form' %>

<%= link_to 'Back', users_path %>

app/views/users/show.html.erb
<div class="header">
  <h1>Your Pins</h1>
  <h3>A Collection of your</h3>
</div>
<hr/>
<div class="pins">
  <% @pins.each_slice(3) do |row| %>
    <div class="row">
      <% row.each do |pin| %>      
        <div class="pin-container col-md-4">
          <div class="pin">

            <div class="logo-thumbnail col-xs-3">
              <% if pin.image.exists? %>
                <img src="<%= pin.image.url(:thumb) %>">
              <% else %>
                <% if "#{pin.category.name}" == "rails" %>
                  <%= image_tag('rails-logo-thumbnail.png') %>
                <% elsif "#{pin.category.name}" == "ruby" %>
                  <%= image_tag('ruby-logo-thumbnail.png') %>                
                <% end %>
              <% end %>
            </div>

            <div class="col-xs-9">
              <h4>
                <%= link_to "#{pin.title}", pin_by_name_path(slug: pin.slug), html_options = {target: "_blank", class: "url"} %>
              </h4>
              <%= link_to "#{pin.url}", pin.url, html_options = {target: "_blank", class: "url"} %>
            </div>

            <hr/>
            <%= link_to repin_path(pin), class: "btn btn-default repin", method: "post" do %>
              <i class="fa fa-thumb-tack"></i>
              Repin!
            <% end %>
            <img src="<%= pin.image.url(:medium) %>">
            <p class="text"><%= "#{pin.text}" %></p>
          </div>
        </div>
      <% end %>
    </div>
  <% end %>
</div>

<hr/>